# This code is made by MRayan Asim
# The turtle is a built-in module of the python but you can install it by:
# pip install Pythonturtle
import turtle


class Cartoon:
    def __init__(self):
        self.t = turtle.Turtle()
        self.t.speed(0)
        self.t.pensize(3)
        self.screen = turtle.Screen()
        self.screen.screensize(1800, 800)
        self.screen.title("Cartoon")
        self.draw_cartoon()
        self.screen.mainloop()

    def meme(self, x, y):
        self.t.penup()
        self.t.goto(x, y)
        self.t.pendown()

    def draw_eye(self, x, y, size, circle_size):
        self.meme(x, y)
        self.t.seth(0)
        self.t.fillcolor("#333333")
        self.t.begin_fill()
        self.t.circle(size)
        self.t.end_fill()

        self.meme(x, y + 10)
        self.t.fillcolor("#000000")
        self.t.begin_fill()
        self.t.circle(size - 12)
        self.t.end_fill()

        self.meme(x + circle_size, y + 22)
        self.t.fillcolor("#ffffff")
        self.t.begin_fill()
        self.t.circle(size - 12)
        self.t.end_fill()

    def draw_mouth(self, x, y):
        self.meme(x, y)
        self.t.fillcolor("#88141D")
        self.t.begin_fill()

        l1 = []
        l2 = []
        self.t.seth(190)
        a = 0.7
        for i in range(28):
            a += 0.1
            self.t.right(3)
            self.t.fd(a)
            l1.append(self.t.position())

        self.meme(x, y)

        self.t.seth(10)
        a = 0.7
        for i in range(28):
            a += 0.1
            self.t.left(3)
            self.t.fd(a)
            l2.append(self.t.position())

        self.t.seth(10)
        self.t.circle(50, 15)
        self.t.left(180)
        self.t.circle(-50, 15)

        self.t.circle(-50, 40)
        self.t.seth(233)
        self.t.circle(-50, 55)
        self.t.left(180)
        self.t.circle(50, 12.1)
        self.t.end_fill()

        self.meme(17, 54)
        self.t.fillcolor("#DD716F")
        self.t.begin_fill()
        self.t.seth(145)
        self.t.circle(40, 86)
        self.t.penup()
        for pos in reversed(l1[:20]):
            self.t.goto(pos[0], pos[1] + 1.5)
        for pos in l2[:20]:
            self.t.goto(pos[0], pos[1] + 1.5)
        self.t.pendown()
        self.t.end_fill()

        self.meme(-17, 94)
        self.t.seth(8)
        self.t.fd(4)
        self.t.back(8)
        self.t.end_fill()

    def draw_cheek(self, x, y):
        turtle.tracer(False)
        self.meme(x, y)
        self.t.seth(300)
        self.t.fillcolor("#DD4D28")
        self.t.begin_fill()
        a = 2.3
        for i in range(120):
            if 0 <= i < 30 or 60 <= i < 90:
                a -= 0.05
                self.t.lt(3)
                self.t.fd(a)
            else:
                a += 0.05
                self.t.lt(3)
                self.t.fd(a)
        self.t.end_fill()
        turtle.tracer(True)

    def draw_ear(self, x, y):
        self.meme(x, y)
        self.t.seth(60)
        self.t.fillcolor("#DD4D28")
        self.t.begin_fill()
        a = 2.3
        for i in range(120):
            if 0 <= i < 30 or 60 <= i < 90:
                a -= 0.05
                self.t.lt(3)
                self.t.fd(a)
            else:
                a += 0.05
                self.t.lt(3)
                self.t.fd(a)
        self.t.end_fill()

    def draw_hair(self, x, y):
        self.meme(x, y)
        self.t.fillcolor("#F6D02F")
        self.t.begin_fill()
        self.t.seth(200)
        self.t.circle(400, 7)
        self.t.left(180)
        self.t.circle(-400, 30)
        self.t.circle(30, 60)
        self.t.fd(50)
        self.t.circle(30, 45)
        self.t.fd(60)
        self.t.left(5)
        self.t.circle(30, 70)
        self.t.right(20)
        self.t.circle(200, 70)
        self.t.circle(30, 60)
        self.t.fd(70)
        self.t.right(35)
        self.t.fd(50)
        self.t.circle(8, 100)
        self.t.end_fill()

    def draw_topi(self):
        self.meme(-134.07, 147.81)
        self.t.seth(36)
        self.t.circle(-270, 54)
        self.t.left(180)
        self.t.circle(270, 27)
        self.t.circle(-80, 98)

        self.meme(-126.82, 156.84)
        self.t.fillcolor("#F6D02F")
        self.t.begin_fill()
        self.t.circle(130, 40)
        self.t.circle(100, 105)
        self.t.left(180)
        self.t.circle(-100, 5)
        self.t.seth(20)
        self.t.circle(300, 30)
        self.t.circle(30, 50)
        self.t.seth(190)
        self.t.circle(300, 36)
        self.t.seth(150)
        self.t.circle(150, 70)
        self.t.seth(200)
        self.t.circle(300, 40)
        self.t.circle(30, 50)
        self.t.seth(20)
        self.t.circle(300, 35)
        self.t.seth(240)
        self.t.circle(105, 95)
        self.t.left(180)
        self.t.circle(-105, 5)
        self.t.seth(210)
        self.t.circle(500, 18)
        self.t.seth(200)
        self.t.fd(10)
        self.t.seth(280)
        self.t.fd(7)
        self.t.seth(210)
        self.t.fd(10)
        self.t.seth(300)
        self.t.circle(10, 80)
        self.t.seth(220)
        self.t.fd(10)
        self.t.seth(300)
        self.t.circle(10, 80)
        self.t.seth(240)
        self.t.fd(12)
        self.t.seth(0)
        self.t.fd(13)
        self.t.seth(240)
        self.t.circle(10, 70)
        self.t.seth(10)
        self.t.circle(10, 70)
        self.t.seth(10)
        self.t.circle(300, 18)
        self.t.seth(75)
        self.t.circle(500, 8)
        self.t.left(180)
        self.t.circle(-500, 15)
        self.t.seth(250)
        self.t.circle(100, 65)
        self.t.seth(320)
        self.t.circle(100, 5)
        self.t.left(180)
        self.t.circle(-100, 5)
        self.t.seth(220)
        self.t.circle(200, 20)
        self.t.circle(20, 70)
        self.t.seth(60)
        self.t.circle(-100, 20)
        self.t.left(180)
        self.t.circle(100, 20)
        self.t.seth(300)
        self.t.circle(10, 70)
        self.t.seth(60)
        self.t.circle(-100, 20)
        self.t.left(180)
        self.t.circle(100, 20)
        self.t.seth(10)
        self.t.circle(100, 60)
        self.t.seth(180)
        self.t.circle(-100, 10)
        self.t.left(180)
        self.t.circle(100, 10)
        self.t.seth(5)
        self.t.circle(100, 10)
        self.t.circle(-100, 40)
        self.t.circle(100, 35)
        self.t.left(180)
        self.t.circle(-100, 10)
        self.t.seth(290)
        self.t.circle(100, 55)
        self.t.circle(10, 50)
        self.t.seth(120)
        self.t.circle(100, 20)
        self.t.left(180)
        self.t.circle(-100, 20)
        self.t.seth(0)
        self.t.circle(10, 50)
        self.t.seth(110)
        self.t.circle(100, 20)
        self.t.left(180)
        self.t.circle(-100, 20)
        self.t.seth(30)
        self.t.circle(20, 50)
        self.t.seth(100)
        self.t.circle(100, 40)
        self.t.seth(200)
        self.t.circle(-100, 5)
        self.t.left(180)
        self.t.circle(100, 5)
        self.t.left(30)
        self.t.fd(10)
        self.t.circle(-5, 160)
        self.t.fd(10)
        self.meme(-30, 280)
        self.t.fillcolor("#228B22")
        self.t.begin_fill()
        self.t.seth(100)
        self.t.circle(30, 180)
        self.t.seth(190)
        self.t.fd(15)
        self.t.seth(100)
        self.t.circle(-45, 180)
        self.t.right(90)
        self.t.fd(15)
        self.t.end_fill()
        self.t.pencolor("#000000")

    def draw_cartoon(self):
        self.draw_eye(-85, 90, 22, 6)
        self.draw_eye(50, 110, 22, -6)
        self.draw_mouth(-5, 25)
        self.draw_cheek(126, 32)
        self.draw_cheek(107, 63)
        self.draw_ear(-250, 100)
        self.draw_ear(140, 270)
        self.draw_hair(130, 125)
        self.draw_mouth(-5, 25)
        self.draw_cheek(126, 32)
        self.draw_cheek(107, 63)
        self.draw_ear(-250, 100)
        self.draw_ear(140, 270)
        self.draw_eye(-85, 90, 22, 6)
        self.draw_eye(50, 110, 22, -6)
        self.draw_mouth(-5, 25)
        self.draw_hair(130, 125)
        self.draw_topi()


if __name__ == "__main__":
    cartoon = Cartoon()
